export type KeyValuePair<K, V> = [key: K, value: V];
export type Bin<K, V> = {
    k: K;
    left: Node<K, V>;
    right: Node<K, V>;
    size: number;
    v: V;
};
export type Node<K, V> = Bin<K, V> | undefined;
export declare const insert: <K, V>(key: K, val: V, node: Node<K, V>) => Node<K, V>;
export declare const remove: <K, V>(key: K, node: Node<K, V>) => Node<K, V>;
export declare const lookup: <K, V>(key: K, node: Node<K, V>) => KeyValuePair<K, V> | undefined;
export declare const traverse: <K, V>(node: Node<K, V>) => Generator<KeyValuePair<K, V>>;
